<?php
//
// +---------------------------------------------------------------------------+
// | nmoxmenu Geeklog Plugin 4.0                                          |
// +---------------------------------------------------------------------------+
// | function.inc                                                              |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2007 by nmox                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/nmoxmenu/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile))
{
	include_once ($langfile);
}
else
{
	include_once ($_CONF['path'] . 'plugins/nmoxmenu/language/english.php');
}

require_once ($_CONF['path'] . 'plugins/nmoxmenu/config.php');

function plugin_chkVersion_nmoxmenu() {
	global $_NMOXMENU;

	return $_NMOXMENU['version'];
}

function plugin_getmenuitems_nmoxmenu()
{
	return false;
}

function plugin_getuseroption_nmoxmenu() 
{
	global $_CONF, $LANG_NMOXMENU,$_NMOXMENU;
	if($_NMOXMENU["show_usermenu"]==1){
		return array(  $LANG_NMOXMENU["nmoxmenu"], $_CONF['site_url'] . '/nmoxmenu/index.php', 0 );
	}
}

function plugin_commentsupport_nmoxmenu()
{
	return false;
}

function plugin_showstats_nmoxmenu($showsitestats)
{
	$retval = '';
	return $retval;
}

function plugin_upgrade_nmoxmenu ()
{
    global $_TABLES, $_NMOXMENU;

    $v = DB_getItem ($_TABLES['plugins'], 'pi_version', "pi_name = 'nmoxmenu'");

    if ($v != $_NMOXMENU['version']) {
        // update version numbers
        DB_query ("UPDATE {$_TABLES['plugins']} SET pi_version = '{$_NMOXMENU['version']}', pi_gl_version = '1.4.1' WHERE pi_name = 'nmoxmenu'");

        // check if version number was updated successfully
        $v = DB_getItem ($_TABLES['plugins'], 'pi_version', "pi_name = 'spamx'");
    }

    if ($v == $_NMOXMENU['version']) {
        return true;
    }

    return true;
}

function plugin_enablestatechange_nmoxmenu ($enable)
{
	global $_TABLES;

	$is_enabled = $enable ? 1 : 0;

	// toggle nmoxmenu block
	DB_query ("UPDATE {$_TABLES['blocks']} SET is_enabled = $is_enabled WHERE (type = 'phpblock') AND (phpblockfn = 'phpblock_nmoxmenu')");
}

function plugin_uninstall_nmoxmenu($installCheck = '')
{
	global $_TABLES,$_CONF,$_DB_table_prefix;

	$pi_name  = 'nmoxmenu';


	$grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_admin'");
	DB_delete($_TABLES['plugins'],'pi_name','nmoxmenu');
	DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
	$FEATURES = array ('nmoxmenu.edit','nmoxmenu.user');
	foreach ($FEATURES as $feature) {
		$feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
		DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
		DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
	}
	DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_admin'");
	DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['blocks']} WHERE name='nmoxmenu'",1);
	/*
	DB_query("drop table {$_TABLES['nmoxmenu_topics']}");
	DB_query("drop table {$_TABLES['nmoxmenu_setting']}");
	DB_query("drop table {$_TABLES['nmoxmenu_favorite']}");
	DB_query("drop table {$_TABLES['nmoxmenu_attributes']}");
	*/
	DB_query("drop table if exists ".$_DB_table_prefix."nmoxmenu_topics");
	DB_query("drop table if exists ".$_DB_table_prefix."nmoxmenu_setting");
	DB_query("drop table if exists ".$_DB_table_prefix."nmoxmenu_favorite");
	DB_query("drop table if exists ".$_DB_table_prefix."nmoxmenu_attributes");
	return true;
}

function plugin_getadminoption_nmoxmenu(){
	global $_CONF, $_NMOXMENU;
	if (SEC_hasRights ('nmoxmenu.edit', 'OR')) {
		return array ($_NMOXMENU['nmoxmenu'], $_CONF['site_admin_url'] . '/plugins/nmoxmenu/index.php');
	}
}

function plugin_getheadercode_nmoxmenu(){
	global $_CONF;
	$str = "<link rel='stylesheet' type='text/css' href='" . $_CONF['site_url'] . "/nmoxmenu/style.css'>\n";
	//$str.= "<script src='" . $_CONF['site_url'] . "/nmoxmenu/functions.js' type='text/javascript'>\n</script>\n";
	return $str;
}

function plugin_cclabel_nmoxmenu(){
	global $_CONF, $LANG_LINKS;

	if (SEC_hasRights ('nmoxmenu.edit')) {
		return array ("nmoxmenu",$_CONF['site_admin_url'] . '/plugins/nmoxmenu/index.php',plugin_geticon_nmoxmenu());
	}
	return false;
}

function plugin_geticon_nmoxmenu(){
	global $_CONF;
	return $_CONF['site_url'] . '/nmoxmenu/images/nmoxlogo.gif';
}

function phpblock_nmoxmenu(){
	global $_TABLES,$_CONF,$_USER,$LANG_NMOXMENU;
	
	//設定読み込み
	$rcns=DB_fetchArray(DB_query("select * from ".$_TABLES["nmoxmenu_setting"]." where id=1"));
	
	//指定時間以前の履歴は削除
	$delete_range=date("YmdHis",mktime(date("H"),(int)(date("i")-$rcns["holdtime"]),date("s"),date("m"),date("d"),date("Y")));
	DB_query("delete from ".$_TABLES["nmoxmenu_favorite"]." where date<='".$delete_range."'");

	//展開履歴を読み込み
	$rcfv=DB_fetchArray(DB_query("select opened from ".$_TABLES["nmoxmenu_favorite"]." where ip='".$_SERVER["REMOTE_ADDR"]."'"));
	$openeds=array_unique(explode(",",$rcfv["opened"]));
	if(in_array($_GET["ntopic"],$openeds)){
		//格納
		$openeds[array_search($_GET["ntopic"],$openeds)]=null;
	}else{
		//展開
		$openeds[]=$_GET["ntopic"];
	}
	//同一IPの履歴は削除
	DB_query("delete from ".$_TABLES["nmoxmenu_favorite"]." where ip='".$_SERVER["REMOTE_ADDR"]."'");

	//展開している話題を記録
	DB_query("insert into ".$_TABLES["nmoxmenu_favorite"]."(ip,opened,date) values('".$_SERVER["REMOTE_ADDR"]."','".implode(",",$openeds)."','".date("YmdHis")."')");
	
	//言語指定のためのSQLを生成
	$sql_lang=COM_getLangSQL("tid","where");
	if($sql_lang==''){
		//$sql_lang=" where tid not like '%\_%'";
	}else{
		$sql_lang=$sql_lang." or tid not like '%\_%'";
	}

	//リンクの下線を表示する
	if($rcns["show_underline"]>0){
		$underline="text-decoration:underline;";
	}else{
		$underline="text-decoration:none;";
	}
	
	$html="
	<div id='nmoxmenu'>
	";
	//ホームリンク
	if(!$_CONF["hide_home_link"]){
		$html.="<div class='nochild' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/'>".(empty($rcns["icon_nochild"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_nochild"]."' />").$LANG_NMOXMENU["home"]."</a></div>\n";
	}
	$rs=DB_query("select * from ".$_TABLES["topics"].$sql_lang." union select * from ".$_TABLES["nmoxmenu_topics"].$sql_lang." order by sortnum asc");
	while($rc=DB_fetchArray($rs)){
		//属性を取得
		$rca=DB_fetchArray(DB_query("select * from ".$_TABLES["nmoxmenu_attributes"]." where tid='".$rc["tid"]."'"));
		
		//含まれる話題があれば表示、なければ非表示
		if($rcns["show_empty_stories"]>0){
			$show_this=1;
		}else{
			$rcs=DB_fetchArray(DB_query("select count(*) as c from ".$_TABLES["stories"]." where tid='".$rc["tid"]."'"));
			if($rcs["c"]==0){
				$show_this=0;
			}else{
				$show_this=1;
			}
		}

                // CUSTOM START By Kitani. 2008.07.15 v1.0
                // 話題に記事が１つもない場合
                // 話題IDと同一の静的ページがあるかどうかチェックする
                // 多言語対応かどうかの判定 
                $sql_lang=COM_getLangSQL("sp_id","where");
                if($sql_lang == '')    
                      $sql_lang = "select sp_id,sp_title from ".$_TABLES["staticpage"]." where sp_id";
                else                                                         
                      $sql_lang = "select sp_id,sp_title from ".$_TABLES["staticpage"]." ". $sql_lang;

                $rsp=DB_query($sql_lang); 	  // 静的ページから全データのIDとタイトルを取得
                $rsp2_rct_match_check=""; // 話題IDと合致する静的ページIDがあった場合の格納
                while($rsp2=DB_fetchArray($rsp)){
                    if($rsp2['sp_id'] == $rc['tid']){              // 合致するものあった
                          $rsp2_rct_match_check=$rsp2['sp_title']; // タイトルを格納
                          $rsp2_id=$rsp2['sp_id'];		   // IDを格納
			  $show_this=1;				   // 見せるべき話題があると判定
                          break;
                    }
                }
                // CUSTOM END (Middle)
		
		//話題の閲覧権限があれば表示、なければ非表示
		if(NMOXMENU_hasTopicAccess($rc["tid"])>0 and $show_this>0){
			$show_this=1;
		}else{
			$show_this=0;
		}
		
		//話題数を表示する設定なら表示、そうでなければ非表示
		if($_CONF['showstorycount']==true and $rca["type"]!="index"){
			$num_stories="<span class='num_stories'>(".NMOXMENU_num_stories($rc["tid"]).")</span>";
		}else{
			$num_stories="";
		}
		
		//話題に色指定があれば指定色、そうでなければデフォルト設定色
		if(!empty($rca["color"])){
			$color=$rca["color"];
		}else{
			$color=$rcns["default_color"];
		}
		if(!empty($rca["bgcolor"])){
			$bgcolor=$rca["bgcolor"];
		}else{
			$bgcolor=$rcns["default_bgcolor"];
		}
		
		//話題アイコンを表示する
		if(($rcns["show_icon"]>0 and !empty($rc["imageurl"]) and substr($rc["imageurl"],-1)!="/") or $rca["type"]=="image"){
			$icon="<img src='".$_CONF["site_url"].$rc["imageurl"]."' /><br />";
		}else{
			$icon="";
		}
		
		switch($rca["type"]){
			case "topic":
			case "image":
			default:
				//話題行
				if($show_this>0){
					//見せるべき話題なら表示
					if($rca["level"]<2){
						//1階層の話題
				                // CUSTOM START (from CUSTOM END: Middle)
				                // 話題IDと同一の静的ページがあれば
				                if(!empty($rsp2_rct_match_check)){       
				                   // URLリライト機能への対応       
				                   if($_CONF['url_rewrite'])
							$html.="<div class='nochild' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/staticpages/index.php/".$rsp2_id."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_nochild"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_nochild"]."' />").$rsp2_rct_match_check)."</a></div>\n";
						   else
							$html.="<div class='nochild' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/staticpages/index.php?page=".$rsp2_id."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_nochild"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_nochild"]."' />").$rsp2_rct_match_check)."</a></div>\n";
						}else{
							$html.="<div class='nochild' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/index.php?topic=".$rc["tid"]."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_nochild"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_nochild"]."' />").$rc["topic"])."</a>".$num_stories."</div>\n";
						}
						// CUSTOM END 
					}else{
						//2階層の話題
						$rci=DB_fetchArray(DB_query("select reverse from ".$_TABLES["nmoxmenu_attributes"]." where tid='".$rca["parent_id"]."'"));
						if(($rci["reverse"]==0 and in_array($rca["parent_id"],$openeds)) or ($rci["reverse"]==1 and !in_array($rca["parent_id"],$openeds))){
				                  // CUSTOM START (from CUSTOM END: Middle)
				                  // 話題IDと同一の静的ページがあれば
			              		  if(!empty($rsp2_rct_match_check)){       
				               	      // URLリライト機能への対応       
				                      if($_CONF['url_rewrite']){
							if($rca["branchend"]>0){
								//2階層の最後尾
								$html.="<div class='branch-end' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/staticpages/index.php/".$rsp2_id."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_tree_end"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_tree_end"]."' />").$rsp2_rct_match_check)."</a></div>\n";
							}else{
								//2階層の最後尾以外
								$html.="<div class='branch' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/staticpages/index.php/".$rsp2_id."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_tree_branch"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_tree_branch"]."' />").$rsp2_rct_match_check)."</a></div>\n";
							}

						      }else{
							if($rca["branchend"]>0){
								//2階層の最後尾
								$html.="<div class='branch-end' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/staticpages/index.php?page=".$rsp2_id."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_tree_end"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_tree_end"]."' />").$rsp2_rct_match_check)."</a></div>\n";
							}else{
								//2階層の最後尾以外
								$html.="<div class='branch' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/staticpages/index.php?page=".$rsp2_id."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_tree_branch"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_tree_branch"]."' />").$rsp2_rct_match_check)."</a></div>\n";
							}

						      }
						   }else{
							if($rca["branchend"]>0){
								//2階層の最後尾
								$html.="<div class='branch-end' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/index.php?topic=".$rc["tid"]."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_tree_end"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_tree_end"]."' />").$rc["topic"])."</a>".$num_stories."</div>\n";
							}else{
								//2階層の最後尾以外
								$html.="<div class='branch' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$_CONF["site_url"]."/index.php?topic=".$rc["tid"]."'>".$icon.($rca["type"]=="image"?"":(empty($rcns["icon_tree_branch"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_tree_branch"]."' />").$rc["topic"])."</a>".$num_stories."</div>\n";
							}
						   } // CUSTOM END
						}
					}
				}
				break;
			case "index":
				//見出し行
				if(in_array($rc["tid"],$openeds)){
					if($rca["reverse"]==0){
						$icon="".$icon.(empty($rcns["icon_open"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_open"]."' />");
					}else{
						$icon="".$icon.(empty($rcns["icon_close"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_close"]."' />");
					}
				}else{
					if($rca["reverse"]==0){
						$icon="".$icon.(empty($rcns["icon_close"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_close"]."' />");
					}else{
						$icon="".$icon.(empty($rcns["icon_open"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_open"]."' />");
					}
				}
				$qs=explode("ntopic",$_SERVER["QUERY_STRING"]);
				if(substr($qs[0],-1)=="&"){
					$qs[0]=substr($qs[0],0,strlen($qs[0])-1);
				}
				$uri=$_SERVER["SCRIPT_NAME"].(empty($qs[0])?"?":"?".$qs[0]."&")."ntopic=".$rc["tid"];
				$html.="<div class='index' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$uri."'>".$icon.$rc["topic"]."</a>".$num_stories."</div>\n";
				break;
			case "border":
				//境界線行
				$html.="<div class='border' style='background-color:".$bgcolor.";'><hr style='color:".$color.";' /></div>\n";
				break;
			case "hidden":
				//隠し行
				break;
			case "link":
				//リンク行
				if($show_this>0){
					//見せるべきリンクなら表示
					if($rca["level"]<2){
						//1階層のリンク
						$html.="<div class='nochild' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$rca["link"]."'>".$icon.(empty($rcns["icon_nochild"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_nochild"]."' />").$rc["topic"]."</a></div>\n";
					}else{
						//2階層のリンク
						$rci=DB_fetchArray(DB_query("select reverse from ".$_TABLES["nmoxmenu_attributes"]." where tid='".$rca["parent_id"]."'"));
						if(($rci["reverse"]==0 and in_array($rca["parent_id"],$openeds)) or ($rci["reverse"]==1 and !in_array($rca["parent_id"],$openeds))){
							if($rca["branchend"]>0){
								//2階層の最後尾
								$html.="<div class='branch-end' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$rca["link"]."'>".(empty($rcns["icon_tree_end"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_tree_end"]."' />").$rc["topic"]."</a></div>\n";
							}else{
								//2階層の最後尾以外
								$html.="<div class='branch' style='background-color:".$bgcolor.";'><a style='color:".$color.";".$underline."' href='".$rca["link"]."'>".(empty($rcns["icon_tree_branch"])?"":"<img class='icon' src='".$_CONF["site_url"]."/nmoxmenu/images/".$rcns["icon_tree_branch"]."' />").$rc["topic"]."</a></div>\n";
							}
						}
					}
				}
				break;
		}
	}
	
	$html.="</div>\n";
	return $html;
}

function NMOXMENU_num_stories($tid){
	//閲覧可能な記事数をカウント
	global $_TABLES;
	$show_num_stories=0;
	$sql="select * from ".$_TABLES["stories"]." where draft_flag=0 and date<'".date("Y-m-d H:i:s")."' and tid='".$tid."'";
	$rs=DB_query($sql);
	while($rc=DB_fetchArray($rs)){
		$permission=SEC_hasAccess($rc["owner_id"],$rc["group_id"],$rc["perm_owner"],$rc["perm_group"],$rc["perm_members"],$rc["perm_anon"]);
		if($permission>1){
			$show_num_stories++;
		}
	}
	return $show_num_stories;
}

function NMOXMENU_hasTopicAccess($tid){
	//閲覧権限を確認
	global $_TABLES;

	if (empty($tid)) {
		return 0;
	}

	$result = DB_query("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['topics']} WHERE tid = '$tid'");
	$A = DB_fetchArray($result);
	$val1=SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);

	$result = DB_query("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['nmoxmenu_topics']} WHERE tid = '$tid'");
	$A = DB_fetchArray($result);
	$val2=SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);

	if($val1 or $val2){
		$val=1;
	}else{
		$val=0;
	}
	return $val;
}

?>
